#include <smlib>

#if defined _smlib_effects_included
  #endinput
#endif
#define _smlib_effects_included

stock Effect_DissolvePlayer(client) {

	if (!IsClientInGame(client)) {
		return;
	}
    
	new ragdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");

	if (ragdoll == -1) {
		return;
	}

	new String:dname[8];
	Format(dname, sizeof(dname), "dis_%d", client);

	new entity = CreateEntityByName("env_entity_dissolver");

	if (entity == -1) {
		return;
	}

	DispatchKeyValue(ragdoll, "targetname", dname);

	DispatchKeyValue(entity, "dissolvetype", "0");
	DispatchKeyValue(entity, "target", dname);
	AcceptEntityInput(entity, "Dissolve");
	AcceptEntityInput(entity, "kill");

}

stock Effect_FadeOut(entity, kill=false) {
	
	SetEntityRenderMode(entity, RENDER_TRANSCOLOR);
	
	if (kill) {
		CreateTimer(0.1, Timer_Effect_FadeOutAndKill, entity, TIMER_REPEAT);
	}
	else {
		CreateTimer(0.1, Timer_Effect_FadeOut, entity, TIMER_REPEAT);
	}
}

public Action:Timer_Effect_FadeOutAndKill(Handle:Timer, any:entity) {

	if (!IsValidEntity(entity)) {

		return Plugin_Stop;
	}

	new m_clrRender = GetEntSendPropOffs(entity, "m_clrRender");
	new alpha = GetEntData(entity, m_clrRender + 3, 1);

	alpha -= 51;
	if (alpha <= 0) {
		alpha = 0;
		
		//ExitVehicle(entity);

		AcceptEntityInput(entity, "kill");
		
		return Plugin_Stop;
	}

	SetEntData(entity, m_clrRender + 3, alpha, 1, true);
	
	return Plugin_Continue;
}

stock Effect_FadeIn(entity) {

	new m_clrRender = GetEntSendPropOffs(entity, "m_clrRender");
	SetEntData(entity, m_clrRender+3,	0, 1, true);
	CreateTimer(0.1, Timer_Effect_FadeIn, entity, TIMER_REPEAT);
}

public Action:Timer_Effect_FadeIn(Handle:Timer, any:entity) {

	if (!IsValidEntity(entity)) {

		return Plugin_Stop;
	}

	new m_clrRender = GetEntSendPropOffs(entity, "m_clrRender");
	new alpha = GetEntData(entity, m_clrRender + 3, 1);

	alpha += 51;
	if (alpha >= 255) {
		alpha = 255;
	}

	SetEntData(entity, m_clrRender + 3, alpha, 1, true);
	
	if (alpha == 255) {
		return Plugin_Stop;
	}
	
	return Plugin_Continue;
}

public Action:Timer_Effect_FadeOut(Handle:Timer, any:entity) {

	if (!IsValidEntity(entity)) {

		return Plugin_Stop;
	}

	new m_clrRender = GetEntSendPropOffs(entity, "m_clrRender");
	new alpha = GetEntData(entity, m_clrRender + 3, 1);

	alpha -= 51;
	if (alpha <= 0) {
		alpha = 0;
		
		return Plugin_Stop;
	}

	SetEntData(entity, m_clrRender + 3, alpha, 1, true);
	
	return Plugin_Continue;
}
